
_Main_Init:

;electronique_orgue_006_18f2520.mpas,96 :: 		begin
;electronique_orgue_006_18f2520.mpas,97 :: 		CMCON := CMCON or $07;     // turn off comparators
	MOVLW       7
	IORWF       CMCON+0, 1 
;electronique_orgue_006_18f2520.mpas,98 :: 		ADCON1 := ADCON1 or $0F;   // turn off analog inputs
	MOVLW       15
	IORWF       ADCON1+0, 1 
;electronique_orgue_006_18f2520.mpas,99 :: 		INTCON := $00;
	CLRF        INTCON+0 
;electronique_orgue_006_18f2520.mpas,100 :: 		INTCON2 := $00;
	CLRF        INTCON2+0 
;electronique_orgue_006_18f2520.mpas,101 :: 		INTCON2.NOT_RBPU := 1;     // disable pullup
	BSF         INTCON2+0, 7 
;electronique_orgue_006_18f2520.mpas,102 :: 		TRISA := %11111111;
	MOVLW       255
	MOVWF       TRISA+0 
;electronique_orgue_006_18f2520.mpas,103 :: 		TRISB := %11111111;
	MOVLW       255
	MOVWF       TRISB+0 
;electronique_orgue_006_18f2520.mpas,104 :: 		TRISC := %11101111;
	MOVLW       239
	MOVWF       TRISC+0 
;electronique_orgue_006_18f2520.mpas,105 :: 		PORTA := $00;
	CLRF        PORTA+0 
;electronique_orgue_006_18f2520.mpas,106 :: 		PORTB := $00;
	CLRF        PORTB+0 
;electronique_orgue_006_18f2520.mpas,107 :: 		PORTC := $00;
	CLRF        PORTC+0 
;electronique_orgue_006_18f2520.mpas,110 :: 		TXSTA := $00;
	CLRF        TXSTA+0 
;electronique_orgue_006_18f2520.mpas,111 :: 		TXSTA.TX9 := 0;     // 8-bits transmission
	BCF         TXSTA+0, 6 
;electronique_orgue_006_18f2520.mpas,112 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF         TXSTA+0, 5 
;electronique_orgue_006_18f2520.mpas,113 :: 		RCSTA := $00;
	CLRF        RCSTA+0 
;electronique_orgue_006_18f2520.mpas,114 :: 		RCSTA.SPEN := 1;
	BSF         RCSTA+0, 7 
;electronique_orgue_006_18f2520.mpas,115 :: 		UART1_Init(31250);  // speed for MIDI communication
	MOVLW       23
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;electronique_orgue_006_18f2520.mpas,116 :: 		Delay_ms(100);      // let UART stabilise
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L__Main_Init1:
	DECFSZ      R13, 1, 1
	BRA         L__Main_Init1
	DECFSZ      R12, 1, 1
	BRA         L__Main_Init1
	DECFSZ      R11, 1, 1
	BRA         L__Main_Init1
;electronique_orgue_006_18f2520.mpas,119 :: 		Sound_Init(PORTC, 5);
	MOVLW       PORTC+0
	MOVWF       FARG_Sound_Init_snd_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Sound_Init_snd_port+1 
	MOVLW       5
	MOVWF       FARG_Sound_Init_snd_pin+0 
	CALL        _Sound_Init+0, 0
;electronique_orgue_006_18f2520.mpas,121 :: 		iOctave := 3;
	MOVLW       3
	MOVWF       _iOctave+0 
;electronique_orgue_006_18f2520.mpas,122 :: 		iMode := 0;
	CLRF        _iMode+0 
;electronique_orgue_006_18f2520.mpas,123 :: 		for idx := 0 to 12 do
	CLRF        _idx+0 
L__Main_Init3:
;electronique_orgue_006_18f2520.mpas,124 :: 		Notes[idx].OldState := 1;
	MOVF        _idx+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       3
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Notes+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(_Notes+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVLW       1
	MOVWF       POSTINC1+0 
	MOVF        _idx+0, 0 
	XORLW       12
	BTFSC       STATUS+0, 2 
	GOTO        L__Main_Init6
	INCF        _idx+0, 1 
	GOTO        L__Main_Init3
L__Main_Init6:
;electronique_orgue_006_18f2520.mpas,126 :: 		end;
	RETURN      0
; end of _Main_Init

_MIDI_Note_Play:

;electronique_orgue_006_18f2520.mpas,129 :: 		begin
;electronique_orgue_006_18f2520.mpas,130 :: 		UART1_Write(Data1);
	MOVF        FARG_MIDI_Note_Play_Data1+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;electronique_orgue_006_18f2520.mpas,131 :: 		UART1_Write(Data2);
	MOVF        FARG_MIDI_Note_Play_Data2+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;electronique_orgue_006_18f2520.mpas,132 :: 		UART1_Write(Data3);
	MOVF        FARG_MIDI_Note_Play_Data3+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;electronique_orgue_006_18f2520.mpas,133 :: 		end;
	RETURN      0
; end of _MIDI_Note_Play

_Main_Welcome:

;electronique_orgue_006_18f2520.mpas,136 :: 		begin
;electronique_orgue_006_18f2520.mpas,138 :: 		MIDI_Note_Play(cMIDI_Note_On, cMIDI_Note_Pitch_Do3, 100);
	MOVLW       144
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVLW       60
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	MOVLW       100
	MOVWF       FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,140 :: 		Delay_ms(100);
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L__Main_Welcome9:
	DECFSZ      R13, 1, 1
	BRA         L__Main_Welcome9
	DECFSZ      R12, 1, 1
	BRA         L__Main_Welcome9
	DECFSZ      R11, 1, 1
	BRA         L__Main_Welcome9
;electronique_orgue_006_18f2520.mpas,142 :: 		MIDI_Note_Play(cMIDI_Note_Off, cMIDI_Note_Pitch_Do3, cMIDI_Note_Vel_Off);
	MOVLW       128
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVLW       60
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	CLRF        FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,143 :: 		end;
	RETURN      0
; end of _Main_Welcome

_Octave_Inc:

;electronique_orgue_006_18f2520.mpas,146 :: 		begin
;electronique_orgue_006_18f2520.mpas,147 :: 		if iOctave < 5 then
	MOVLW       5
	SUBWF       _iOctave+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Octave_Inc12
;electronique_orgue_006_18f2520.mpas,148 :: 		inc(iOctave);
	INCF        _iOctave+0, 1 
L__Octave_Inc12:
;electronique_orgue_006_18f2520.mpas,149 :: 		end;
	RETURN      0
; end of _Octave_Inc

_Octave_Dec:

;electronique_orgue_006_18f2520.mpas,152 :: 		begin
;electronique_orgue_006_18f2520.mpas,153 :: 		if iOctave > 0 then
	MOVF        _iOctave+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__Octave_Dec16
;electronique_orgue_006_18f2520.mpas,154 :: 		dec(iOctave);
	DECF        _iOctave+0, 1 
L__Octave_Dec16:
;electronique_orgue_006_18f2520.mpas,155 :: 		end;
	RETURN      0
; end of _Octave_Dec

_Mode_Change:

;electronique_orgue_006_18f2520.mpas,158 :: 		begin
;electronique_orgue_006_18f2520.mpas,159 :: 		if iMode < 1 then
	MOVLW       1
	SUBWF       _iMode+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Mode_Change20
;electronique_orgue_006_18f2520.mpas,160 :: 		inc(iMode)
	INCF        _iMode+0, 1 
	GOTO        L__Mode_Change21
;electronique_orgue_006_18f2520.mpas,161 :: 		else
L__Mode_Change20:
;electronique_orgue_006_18f2520.mpas,162 :: 		iMode := 0;
	CLRF        _iMode+0 
L__Mode_Change21:
;electronique_orgue_006_18f2520.mpas,163 :: 		Out_Mode := (iMode > 0);
	MOVF        _iMode+0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	BTFSC       R0, 0 
	GOTO        L__Mode_Change223
	BCF         RC4_bit+0, 4 
	GOTO        L__Mode_Change224
L__Mode_Change223:
	BSF         RC4_bit+0, 4 
L__Mode_Change224:
;electronique_orgue_006_18f2520.mpas,164 :: 		end;
	RETURN      0
; end of _Mode_Change

_MIDI_GetNoteToPlay:

;electronique_orgue_006_18f2520.mpas,167 :: 		begin
;electronique_orgue_006_18f2520.mpas,170 :: 		00 : result := cMIDI_Note_Pitch_Do3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay26
	MOVLW       60
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay26:
;electronique_orgue_006_18f2520.mpas,171 :: 		01 : result := cMIDI_Note_Pitch_DoD3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay29
	MOVLW       61
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay29:
;electronique_orgue_006_18f2520.mpas,172 :: 		02 : result := cMIDI_Note_Pitch_Re3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay32
	MOVLW       62
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay32:
;electronique_orgue_006_18f2520.mpas,173 :: 		03 : result := cMIDI_Note_Pitch_ReD3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay35
	MOVLW       63
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay35:
;electronique_orgue_006_18f2520.mpas,174 :: 		04 : result := cMIDI_Note_Pitch_Mi3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay38
	MOVLW       64
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay38:
;electronique_orgue_006_18f2520.mpas,175 :: 		05 : result := cMIDI_Note_Pitch_Fa3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay41
	MOVLW       65
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay41:
;electronique_orgue_006_18f2520.mpas,176 :: 		06 : result := cMIDI_Note_Pitch_FaD3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay44
	MOVLW       66
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay44:
;electronique_orgue_006_18f2520.mpas,177 :: 		07 : result := cMIDI_Note_Pitch_Sol3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay47
	MOVLW       67
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay47:
;electronique_orgue_006_18f2520.mpas,178 :: 		08 : result := cMIDI_Note_Pitch_SolD3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay50
	MOVLW       68
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay50:
;electronique_orgue_006_18f2520.mpas,179 :: 		09 : result := cMIDI_Note_Pitch_La3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay53
	MOVLW       69
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay53:
;electronique_orgue_006_18f2520.mpas,180 :: 		10 : result := cMIDI_Note_Pitch_LaD3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay56
	MOVLW       70
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay56:
;electronique_orgue_006_18f2520.mpas,181 :: 		11 : result := cMIDI_Note_Pitch_Si3;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay59
	MOVLW       71
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay59:
;electronique_orgue_006_18f2520.mpas,182 :: 		12 : result := cMIDI_Note_Pitch_Do4;
	MOVF        FARG_MIDI_GetNoteToPlay_idx+0, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay62
	MOVLW       72
	MOVWF       R1 
	GOTO        L__MIDI_GetNoteToPlay23
L__MIDI_GetNoteToPlay62:
L__MIDI_GetNoteToPlay23:
;electronique_orgue_006_18f2520.mpas,186 :: 		0 : result := result - (3 * 12);
	MOVF        _iOctave+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay66
	MOVLW       36
	SUBWF       R1, 1 
	GOTO        L__MIDI_GetNoteToPlay63
L__MIDI_GetNoteToPlay66:
;electronique_orgue_006_18f2520.mpas,187 :: 		1 : result := result - (2 * 12);
	MOVF        _iOctave+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay69
	MOVLW       24
	SUBWF       R1, 1 
	GOTO        L__MIDI_GetNoteToPlay63
L__MIDI_GetNoteToPlay69:
;electronique_orgue_006_18f2520.mpas,188 :: 		2 : result := result - (1 * 12);
	MOVF        _iOctave+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay72
	MOVLW       12
	SUBWF       R1, 1 
	GOTO        L__MIDI_GetNoteToPlay63
L__MIDI_GetNoteToPlay72:
;electronique_orgue_006_18f2520.mpas,190 :: 		4 : result := result + (1 * 12);
	MOVF        _iOctave+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay75
	MOVLW       12
	ADDWF       R1, 1 
	GOTO        L__MIDI_GetNoteToPlay63
L__MIDI_GetNoteToPlay75:
;electronique_orgue_006_18f2520.mpas,191 :: 		5 : result := result + (2 * 12);
	MOVF        _iOctave+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__MIDI_GetNoteToPlay78
	MOVLW       24
	ADDWF       R1, 1 
	GOTO        L__MIDI_GetNoteToPlay63
L__MIDI_GetNoteToPlay78:
L__MIDI_GetNoteToPlay63:
;electronique_orgue_006_18f2520.mpas,193 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
	RETURN      0
; end of _MIDI_GetNoteToPlay

_Audio_GetFreqToPlay:

;electronique_orgue_006_18f2520.mpas,196 :: 		begin
;electronique_orgue_006_18f2520.mpas,198 :: 		00 : result := cFreqDo3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay83
	MOVLW       6
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay83:
;electronique_orgue_006_18f2520.mpas,199 :: 		01 : result := cFreqDoD3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay86
	MOVLW       21
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay86:
;electronique_orgue_006_18f2520.mpas,200 :: 		02 : result := cFreqRe3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay89
	MOVLW       38
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay89:
;electronique_orgue_006_18f2520.mpas,201 :: 		03 : result := cFreqReD3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay92
	MOVLW       55
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay92:
;electronique_orgue_006_18f2520.mpas,202 :: 		04 : result := cFreqMi3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay95
	MOVLW       74
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay95:
;electronique_orgue_006_18f2520.mpas,203 :: 		05 : result := cFreqFa3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay98
	MOVLW       93
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay98:
;electronique_orgue_006_18f2520.mpas,204 :: 		06 : result := cFreqFaD3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay101
	MOVLW       114
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay101:
;electronique_orgue_006_18f2520.mpas,205 :: 		07 : result := cFreqSol3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay104
	MOVLW       136
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay104:
;electronique_orgue_006_18f2520.mpas,206 :: 		08 : result := cFreqSolD3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay107
	MOVLW       159
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay107:
;electronique_orgue_006_18f2520.mpas,207 :: 		09 : result := cFreqLa3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay110
	MOVLW       184
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay110:
;electronique_orgue_006_18f2520.mpas,208 :: 		10 : result := cFreqLaD3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay113
	MOVLW       210
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay113:
;electronique_orgue_006_18f2520.mpas,209 :: 		11 : result := cFreqSi3;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay116
	MOVLW       238
	MOVWF       R3 
	MOVLW       1
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay116:
;electronique_orgue_006_18f2520.mpas,210 :: 		12 : result := cFreqDo4;
	MOVF        FARG_Audio_GetFreqToPlay_idx+0, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay119
	MOVLW       11
	MOVWF       R3 
	MOVLW       2
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay80
L__Audio_GetFreqToPlay119:
L__Audio_GetFreqToPlay80:
;electronique_orgue_006_18f2520.mpas,213 :: 		0 : result := result / 8;
	MOVF        _iOctave+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay123
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay120
L__Audio_GetFreqToPlay123:
;electronique_orgue_006_18f2520.mpas,214 :: 		1 : result := result / 4;
	MOVF        _iOctave+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay126
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay120
L__Audio_GetFreqToPlay126:
;electronique_orgue_006_18f2520.mpas,215 :: 		2 : result := result / 2;
	MOVF        _iOctave+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay129
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay120
L__Audio_GetFreqToPlay129:
;electronique_orgue_006_18f2520.mpas,217 :: 		4 : result := result * 2;
	MOVF        _iOctave+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay132
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay120
L__Audio_GetFreqToPlay132:
;electronique_orgue_006_18f2520.mpas,218 :: 		5 : result := result * 4;
	MOVF        _iOctave+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__Audio_GetFreqToPlay135
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	GOTO        L__Audio_GetFreqToPlay120
L__Audio_GetFreqToPlay135:
L__Audio_GetFreqToPlay120:
;electronique_orgue_006_18f2520.mpas,220 :: 		end;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RETURN      0
; end of _Audio_GetFreqToPlay

_Audio_Note_Play:

;electronique_orgue_006_18f2520.mpas,225 :: 		begin
;electronique_orgue_006_18f2520.mpas,228 :: 		Sound_Play(iFreq, cNoteDuration);
	MOVF        FARG_Audio_Note_Play_iFreq+0, 0 
	MOVWF       FARG_Sound_Play_freq_in_hz+0 
	MOVF        FARG_Audio_Note_Play_iFreq+1, 0 
	MOVWF       FARG_Sound_Play_freq_in_hz+1 
	MOVLW       244
	MOVWF       FARG_Sound_Play_duration_ms+0 
	MOVLW       1
	MOVWF       FARG_Sound_Play_duration_ms+1 
	CALL        _Sound_Play+0, 0
;electronique_orgue_006_18f2520.mpas,229 :: 		end;
	RETURN      0
; end of _Audio_Note_Play

_Key_Changed:

;electronique_orgue_006_18f2520.mpas,235 :: 		begin
;electronique_orgue_006_18f2520.mpas,242 :: 		iMidiNoteToSend := MIDI_GetNoteToPlay(idx);
	MOVF        FARG_Key_Changed_idx+0, 0 
	MOVWF       FARG_MIDI_GetNoteToPlay_idx+0 
	CALL        _MIDI_GetNoteToPlay+0, 0
	MOVF        R0, 0 
	MOVWF       Key_Changed_iMidiNoteToSend+0 
;electronique_orgue_006_18f2520.mpas,244 :: 		iFreqToPlay := Audio_GetFreqToPlay(idx);
	MOVF        FARG_Key_Changed_idx+0, 0 
	MOVWF       FARG_Audio_GetFreqToPlay_idx+0 
	CALL        _Audio_GetFreqToPlay+0, 0
	MOVF        R0, 0 
	MOVWF       Key_Changed_iFreqToPlay+0 
	MOVF        R1, 0 
	MOVWF       Key_Changed_iFreqToPlay+1 
;electronique_orgue_006_18f2520.mpas,249 :: 		if (iMode = 0) and (bNewState = 0) then
	MOVF        _iMode+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Key_Changed_bNewState+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Key_Changed139
;electronique_orgue_006_18f2520.mpas,251 :: 		if In_IntSound = 1 then
	BTFSS       RC3_bit+0, 3 
	GOTO        L__Key_Changed142
;electronique_orgue_006_18f2520.mpas,254 :: 		Audio_Note_Play(iFreqToPlay);
	MOVF        Key_Changed_iFreqToPlay+0, 0 
	MOVWF       FARG_Audio_Note_Play_iFreq+0 
	MOVF        Key_Changed_iFreqToPlay+1, 0 
	MOVWF       FARG_Audio_Note_Play_iFreq+1 
	CALL        _Audio_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,255 :: 		end
	GOTO        L__Key_Changed143
;electronique_orgue_006_18f2520.mpas,256 :: 		else
L__Key_Changed142:
;electronique_orgue_006_18f2520.mpas,259 :: 		MIDI_Note_Play(cMIDI_Note_On, iMidiNoteToSend, 100);
	MOVLW       144
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVF        Key_Changed_iMidiNoteToSend+0, 0 
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	MOVLW       100
	MOVWF       FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,261 :: 		Delay_ms(100);
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L__Key_Changed144:
	DECFSZ      R13, 1, 1
	BRA         L__Key_Changed144
	DECFSZ      R12, 1, 1
	BRA         L__Key_Changed144
	DECFSZ      R11, 1, 1
	BRA         L__Key_Changed144
;electronique_orgue_006_18f2520.mpas,263 :: 		MIDI_Note_Play(cMIDI_Note_Off, iMidiNoteToSend, cMIDI_Note_Vel_Off);
	MOVLW       128
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVF        Key_Changed_iMidiNoteToSend+0, 0 
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	CLRF        FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,264 :: 		end;
L__Key_Changed143:
;electronique_orgue_006_18f2520.mpas,265 :: 		end
	GOTO        L__Key_Changed140
;electronique_orgue_006_18f2520.mpas,268 :: 		else if (iMode = 1) and (bNewState = 0) then
L__Key_Changed139:
	MOVF        _iMode+0, 0 
	XORLW       1
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Key_Changed_bNewState+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Key_Changed146
;electronique_orgue_006_18f2520.mpas,270 :: 		if In_IntSound = 1 then
	BTFSS       RC3_bit+0, 3 
	GOTO        L__Key_Changed149
;electronique_orgue_006_18f2520.mpas,273 :: 		Audio_Note_Play(iFreqToPlay);
	MOVF        Key_Changed_iFreqToPlay+0, 0 
	MOVWF       FARG_Audio_Note_Play_iFreq+0 
	MOVF        Key_Changed_iFreqToPlay+1, 0 
	MOVWF       FARG_Audio_Note_Play_iFreq+1 
	CALL        _Audio_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,274 :: 		end
	GOTO        L__Key_Changed150
;electronique_orgue_006_18f2520.mpas,275 :: 		else
L__Key_Changed149:
;electronique_orgue_006_18f2520.mpas,278 :: 		MIDI_Note_Play(cMIDI_Note_On, iMidiNoteToSend, 100);
	MOVLW       144
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVF        Key_Changed_iMidiNoteToSend+0, 0 
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	MOVLW       100
	MOVWF       FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,279 :: 		end;
L__Key_Changed150:
;electronique_orgue_006_18f2520.mpas,280 :: 		end
	GOTO        L__Key_Changed147
;electronique_orgue_006_18f2520.mpas,283 :: 		else if (iMode = 1) and (bNewState = 1) then
L__Key_Changed146:
	MOVF        _iMode+0, 0 
	XORLW       1
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Key_Changed_bNewState+0, 0 
	XORLW       1
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Key_Changed152
;electronique_orgue_006_18f2520.mpas,285 :: 		if In_IntSound = 0 then
	BTFSC       RC3_bit+0, 3 
	GOTO        L__Key_Changed155
;electronique_orgue_006_18f2520.mpas,288 :: 		MIDI_Note_Play(cMIDI_Note_Off, iMidiNoteToSend, cMIDI_Note_Vel_Off);
	MOVLW       128
	MOVWF       FARG_MIDI_Note_Play_Data1+0 
	MOVF        Key_Changed_iMidiNoteToSend+0, 0 
	MOVWF       FARG_MIDI_Note_Play_Data2+0 
	CLRF        FARG_MIDI_Note_Play_Data3+0 
	CALL        _MIDI_Note_Play+0, 0
;electronique_orgue_006_18f2520.mpas,289 :: 		end;
L__Key_Changed155:
;electronique_orgue_006_18f2520.mpas,290 :: 		end;
L__Key_Changed152:
L__Key_Changed147:
L__Key_Changed140:
;electronique_orgue_006_18f2520.mpas,294 :: 		if In_IntSound = 0 then
	BTFSC       RC3_bit+0, 3 
	GOTO        L__Key_Changed158
;electronique_orgue_006_18f2520.mpas,295 :: 		Notes[idx].OldState := bNewState;
	MOVF        FARG_Key_Changed_idx+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       3
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Notes+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(_Notes+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Key_Changed_bNewState+0, 0 
	MOVWF       POSTINC1+0 
L__Key_Changed158:
;electronique_orgue_006_18f2520.mpas,296 :: 		end;
	RETURN      0
; end of _Key_Changed

_main:

;electronique_orgue_006_18f2520.mpas,298 :: 		begin
;electronique_orgue_006_18f2520.mpas,299 :: 		Main_Init;
	CALL        _Main_Init+0, 0
;electronique_orgue_006_18f2520.mpas,300 :: 		Main_Welcome;  // send Do3 MIDI note
	CALL        _Main_Welcome+0, 0
;electronique_orgue_006_18f2520.mpas,301 :: 		while true do
L__main162:
;electronique_orgue_006_18f2520.mpas,306 :: 		if In_Note_Do3 <> Notes[0].OldState then Key_Changed(0, In_Note_Do3);
	CLRF        R1 
	BTFSC       RB0_bit+0, 0 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main167
	CLRF        FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB0_bit+0, 0 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main167:
;electronique_orgue_006_18f2520.mpas,307 :: 		if In_Note_DoD3 <> Notes[1].OldState then Key_Changed(1, In_Note_DoD3);
	CLRF        R1 
	BTFSC       RB1_bit+0, 1 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+3, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main170
	MOVLW       1
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB1_bit+0, 1 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main170:
;electronique_orgue_006_18f2520.mpas,308 :: 		if In_Note_Re3 <> Notes[2].OldState then Key_Changed(2, In_Note_Re3);
	CLRF        R1 
	BTFSC       RB2_bit+0, 2 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+6, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main173
	MOVLW       2
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB2_bit+0, 2 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main173:
;electronique_orgue_006_18f2520.mpas,309 :: 		if In_Note_ReD3 <> Notes[3].OldState then Key_Changed(3, In_Note_ReD3);
	CLRF        R1 
	BTFSC       RB3_bit+0, 3 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+9, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main176
	MOVLW       3
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB3_bit+0, 3 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main176:
;electronique_orgue_006_18f2520.mpas,310 :: 		if In_Note_Mi3 <> Notes[4].OldState then Key_Changed(4, In_Note_Mi3);
	CLRF        R1 
	BTFSC       RB4_bit+0, 4 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+12, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main179
	MOVLW       4
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB4_bit+0, 4 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main179:
;electronique_orgue_006_18f2520.mpas,311 :: 		if In_Note_Fa3 <> Notes[5].OldState then Key_Changed(5, In_Note_Fa3);
	CLRF        R1 
	BTFSC       RB5_bit+0, 5 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+15, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main182
	MOVLW       5
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB5_bit+0, 5 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main182:
;electronique_orgue_006_18f2520.mpas,312 :: 		if In_Note_FaD3 <> Notes[6].OldState then Key_Changed(6, In_Note_FaD3);
	CLRF        R1 
	BTFSC       RB6_bit+0, 6 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+18, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main185
	MOVLW       6
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB6_bit+0, 6 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main185:
;electronique_orgue_006_18f2520.mpas,313 :: 		if In_Note_Sol3 <> Notes[7].OldState then Key_Changed(7, In_Note_Sol3);
	CLRF        R1 
	BTFSC       RB7_bit+0, 7 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+21, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main188
	MOVLW       7
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RB7_bit+0, 7 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main188:
;electronique_orgue_006_18f2520.mpas,314 :: 		if In_Note_SolD3 <> Notes[8].OldState then Key_Changed(8, In_Note_SolD3);
	CLRF        R1 
	BTFSC       RA0_bit+0, 0 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+24, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main191
	MOVLW       8
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RA0_bit+0, 0 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main191:
;electronique_orgue_006_18f2520.mpas,315 :: 		if In_Note_La3 <> Notes[9].OldState then Key_Changed(9, In_Note_La3);
	CLRF        R1 
	BTFSC       RA1_bit+0, 1 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+27, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main194
	MOVLW       9
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RA1_bit+0, 1 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main194:
;electronique_orgue_006_18f2520.mpas,316 :: 		if In_Note_LaD3 <> Notes[10].OldState then Key_Changed(10, In_Note_LaD3);
	CLRF        R1 
	BTFSC       RA2_bit+0, 2 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+30, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main197
	MOVLW       10
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RA2_bit+0, 2 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main197:
;electronique_orgue_006_18f2520.mpas,317 :: 		if In_Note_Si3 <> Notes[11].OldState then Key_Changed(11, In_Note_Si3);
	CLRF        R1 
	BTFSC       RA3_bit+0, 3 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+33, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main200
	MOVLW       11
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RA3_bit+0, 3 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main200:
;electronique_orgue_006_18f2520.mpas,318 :: 		if In_Note_Do4 <> Notes[12].OldState then Key_Changed(12, In_Note_Do4);
	CLRF        R1 
	BTFSC       RA4_bit+0, 4 
	INCF        R1, 1 
	MOVF        R1, 0 
	XORWF       _Notes+36, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main203
	MOVLW       12
	MOVWF       FARG_Key_Changed_idx+0 
	MOVLW       0
	BTFSC       RA4_bit+0, 4 
	MOVLW       1
	MOVWF       FARG_Key_Changed_bNewState+0 
	CALL        _Key_Changed+0, 0
L__main203:
;electronique_orgue_006_18f2520.mpas,322 :: 		if Button(PORTC, 0, 150, 0) and (BtnStates.cBtnStateOctInc = false) then
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       150
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	BTFSC       _BtnStates+1, 5 
	GOTO        L__main225
	BSF         4056, 0 
	GOTO        L__main226
L__main225:
	BCF         4056, 0 
L__main226:
	CLRF        R1 
	BTFSC       4056, 0 
	INCF        R1, 1 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main206
;electronique_orgue_006_18f2520.mpas,324 :: 		BtnStates.cBtnStateOctInc := true;
	BSF         _BtnStates+1, 5 
;electronique_orgue_006_18f2520.mpas,325 :: 		Octave_Inc;
	CALL        _Octave_Inc+0, 0
;electronique_orgue_006_18f2520.mpas,326 :: 		end;
L__main206:
;electronique_orgue_006_18f2520.mpas,327 :: 		if In_OctaveInc = 1 then BtnStates.cBtnStateOctInc := false;
	BTFSS       RC0_bit+0, 0 
	GOTO        L__main209
	BCF         _BtnStates+1, 5 
L__main209:
;electronique_orgue_006_18f2520.mpas,331 :: 		if Button(PORTC, 1, 150, 0) and (BtnStates.cBtnStateOctDec = false) then
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       150
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	BTFSC       _BtnStates+1, 6 
	GOTO        L__main227
	BSF         4056, 0 
	GOTO        L__main228
L__main227:
	BCF         4056, 0 
L__main228:
	CLRF        R1 
	BTFSC       4056, 0 
	INCF        R1, 1 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main212
;electronique_orgue_006_18f2520.mpas,333 :: 		BtnStates.cBtnStateOctDec := true;
	BSF         _BtnStates+1, 6 
;electronique_orgue_006_18f2520.mpas,334 :: 		Octave_Dec;
	CALL        _Octave_Dec+0, 0
;electronique_orgue_006_18f2520.mpas,335 :: 		end;
L__main212:
;electronique_orgue_006_18f2520.mpas,336 :: 		if In_OctaveDec = 1 then BtnStates.cBtnStateOctDec := false;
	BTFSS       RC1_bit+0, 1 
	GOTO        L__main215
	BCF         _BtnStates+1, 6 
L__main215:
;electronique_orgue_006_18f2520.mpas,340 :: 		if Button(PORTC, 2, 150, 0) and (BtnStates.cBtnStateMode = false) then
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       2
	MOVWF       FARG_Button_pin+0 
	MOVLW       150
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	BTFSC       _BtnStates+1, 7 
	GOTO        L__main229
	BSF         4056, 0 
	GOTO        L__main230
L__main229:
	BCF         4056, 0 
L__main230:
	CLRF        R1 
	BTFSC       4056, 0 
	INCF        R1, 1 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main218
;electronique_orgue_006_18f2520.mpas,342 :: 		BtnStates.cBtnStateMode := true;
	BSF         _BtnStates+1, 7 
;electronique_orgue_006_18f2520.mpas,343 :: 		Mode_Change;
	CALL        _Mode_Change+0, 0
;electronique_orgue_006_18f2520.mpas,344 :: 		end;
L__main218:
;electronique_orgue_006_18f2520.mpas,345 :: 		if In_Mode = 1 then BtnStates.cBtnStateMode := false;
	BTFSS       RC2_bit+0, 2 
	GOTO        L__main221
	BCF         _BtnStates+1, 7 
L__main221:
;electronique_orgue_006_18f2520.mpas,347 :: 		end;
	GOTO        L__main162
;electronique_orgue_006_18f2520.mpas,348 :: 		end.
	GOTO        $+0
; end of _main
